﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Telerik.OpenAccess;
using Telerik.OpenAccess.SPI.dataobjects;

namespace OACollectionExtension
{
    public class CustomList<T> : TrackedList<T>
    {
        public override bool Remove(T item)
        {
            IObjectContext context = Database.GetContext(item);
            try
            {
                if (context != null)
                {
                    if (!context.Transaction.IsActive)
                        context.Transaction.Begin();
                    base.Remove(item);
                    context.Remove(item);
                    return true;
                }
                return false;
            }
            catch
            {
                if (context.Transaction.IsActive)
                    context.Transaction.Rollback();
                return false;
            }
        }
        public override void Clear()
        {
            if (this.Count > 0)
            {
                IObjectContext context = Database.GetContext(((PersistenceCapable)this[0]));
                try
                {
                    if (context != null)
                    {
                        if (!context.Transaction.IsActive)
                            context.Transaction.Begin();
                        base.Clear();
                        context.Remove(this);
                    }
                }
                catch
                {
                    if (context.Transaction.IsActive)
                        context.Transaction.Rollback();
                }
            }
        }
    }
}